<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: SharedObject</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: SharedObject</h1>

    




<section>

<header>
    
        <h2><span class="attribs"><span class="type-signature"></span></span>SharedObject<span class="signature">(createJsObject, bereichIndex, isHelper<span class="signature-attributes">opt</span>, postponeInit<span class="signature-attributes">opt</span>, sharedId<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h2>
        
            <div class="class-description">A SharedObject is a wrapper class for CreateJS objects, which stores additional information to synchronize the CreateJS object across devices.</div>
        
    
</header>

<article>
    <div class="container-overview">
    
        

    
    <h2>Constructor</h2>
    

    
    <h4 class="name" id="SharedObject"><span class="type-signature"></span>new SharedObject<span class="signature">(createJsObject, bereichIndex, isHelper<span class="signature-attributes">opt</span>, postponeInit<span class="signature-attributes">opt</span>, sharedId<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Creates a new SharedObject containing the given CreateJS object
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>createJsObject</code></td>
            

            <td class="type">
            
                
<span class="param-type">object</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last">The CreateJS object to wrap</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>bereichIndex</code></td>
            

            <td class="type">
            
                
<span class="param-type">number</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last">The index of the Bereich to show the createJsObject in</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>isHelper</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">True, if this SharedObject is created automatically to represent a property of another SharedObject.</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>postponeInit</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">Set this to true to skip the initialization (defining helpers and setup of watchers). You have to manually call init(), if set to true.</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>sharedId</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last">Set this optional sharedId to recreate a SharedObject with the given sharedId, omit it to create a new SharedObject.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line847">line 847</a>
    </li></ul></dd>
    

    

    

    
</dl>


















    
    </div>

    

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id="bereichIndex"><span class="type-signature"></span>bereichIndex<span class="type-signature"> :number</span></h4>




<div class="description">
    The index of the Bereich the CreateJS object is shown in
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">number</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line865">line 865</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="createJsObject"><span class="type-signature"></span>createJsObject<span class="type-signature"> :createjs.DisplayObject</span></h4>




<div class="description">
    The wrapped CreateJS object
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">createjs.DisplayObject</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line869">line 869</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="helpers"><span class="type-signature"></span>helpers<span class="type-signature"> :Set.&lt;string></span></h4>




<div class="description">
    List of SharedIds, that are used as a helper
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Set.&lt;string></span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line873">line 873</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="isHelper"><span class="type-signature"></span>isHelper<span class="type-signature"> :boolean</span></h4>




<div class="description">
    Is this SharedObject created to represent the property of another SharedObject
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">boolean</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line877">line 877</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="justReceived"><span class="type-signature"></span>justReceived<span class="type-signature"> :Object</span></h4>




<div class="description">
    Store what was just received to prevent calling onChanged when the property is updated
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">Object</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line885">line 885</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="sharedId"><span class="type-signature"></span>sharedId<span class="type-signature"> :string</span></h4>




<div class="description">
    The sharedId of this SharedObject
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">string</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line881">line 881</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="syncProperties"><span class="type-signature"></span>syncProperties<span class="type-signature"> :object</span></h4>




<div class="description">
    Defines which properties sync their changes with the server
</div>



    <h5>Type:</h5>
    <ul>
        <li>
            
<span class="param-type">object</span>


        </li>
    </ul>





<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line892">line 892</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id=".fromSendable"><span class="type-signature">(static) </span>fromSendable<span class="signature">(sendable, postponeInit<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {<a href="SharedObject.html">SharedObject</a>}</span></h4>
    

    



<div class="description">
    Recreates the SharedObject represented by the given Sendable.
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>sendable</code></td>
            

            <td class="type">
            
                
<span class="param-type">Sendable</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last">The Sendable representation of the SharedObject to recreate</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>postponeInit</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">Set this to true to skip the initialization (defining helpers and setup of watchers). You have to manually call init().</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line1052">line 1052</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    The recreated SharedObject.
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="SharedObject.html">SharedObject</a></span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id=".getSharedObject"><span class="type-signature">(static) </span>getSharedObject<span class="signature">(sharedId)</span><span class="type-signature"> &rarr; {<a href="SharedObject.html">SharedObject</a>}</span></h4>
    

    



<div class="description">
    Returns the SharedObject with the given sharedId
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>sharedId</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last">The sharedId of the SharedObject to return</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line1085">line 1085</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    The SharedObject with the given sharedId
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="SharedObject.html">SharedObject</a></span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="delete"><span class="type-signature"></span>delete<span class="signature">(removeCreateJsObject<span class="signature-attributes">opt</span>, skipGarbageCollection<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Removes the SharedObject and the wrapped CreateJS object
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>removeCreateJsObject</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">If true, the wrapped CreateJS object is removed from the Stage as well</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>skipGarbageCollection</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">If this optional parameter is true, the subsequent garbage collection is skipped.This might be useful to prevent multiple runs of the garbage collection when deleting multiple SharedObjects.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line915">line 915</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="init"><span class="type-signature"></span>init<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Creates helpers for SharedObject properties and sets up watchers according to this.syncProperties.This is called automatically unless postponeInit is set in the constructor.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line927">line 927</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="sendable"><span class="type-signature"></span>sendable<span class="signature">()</span><span class="type-signature"> &rarr; {Sendable}</span></h4>
    

    



<div class="description">
    Returns a sendable representation of this SharedObject, but helpers are just referenced and not completely included in the return value.This method is for internal use. Use toSendables to serialize a SharedObject for transmission.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line945">line 945</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    A sendable representation of this SharedObject.
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Sendable</span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="toSendables"><span class="type-signature"></span>toSendables<span class="signature">(independentCopy<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {Object.&lt;string, Sendable>}</span></h4>
    

    



<div class="description">
    Returns an associative Array containing the sendable versions (serializable) of this SharedObject and all helpers needed to recreate this SharedObject.Use this method to transmit a SharedObject.
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>independentCopy</code></td>
            

            <td class="type">
            
                
<span class="param-type">boolean</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    false
                
                </td>
            

            <td class="description last">If true, new SharedIds are used to create a copy that is not synchronized with the original<p hidden>* @returns {{[sharedId: string]: Sendable}} The associative Array containing the sendables of this SharedObject and all helpers needed to recreate this SharedObject.</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="mtlg_distributed_displays.js.html">mtlg_distributed_displays.js</a>, <a href="mtlg_distributed_displays.js.html#line991">line 991</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    The associative Array containing the sendables of this SharedObject and all helpers needed to recreate this SharedObject.
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Object.&lt;string, Sendable></span>


    </dd>
</dl>

    





        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-actions.html">actions</a></li><li><a href="module-communication.html">communication</a></li><li><a href="module-distributedDisplays.html">distributedDisplays</a></li><li><a href="module-rooms.html">rooms</a></li></ul><h3>Classes</h3><ul><li><a href="LinkedArea.html">LinkedArea</a></li><li><a href="SharedObject.html">SharedObject</a></li></ul><h3>Namespaces</h3><ul><li><a href="MTLG.html">MTLG</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Nov 13 2017 14:30:54 GMT+0100 (Mitteleuropäische Zeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>